
 
function [diag_B] = ConstructMtxB_new(n_1, n_2, n_3, delta, varepsilon_out, varepsilon_in,cubic_length,rd_sphere,rd_cylinder)
                                   
n        = n_1 * n_2 * n_3;
diag_B   = varepsilon_out * ones(3*n,1);

%
% (I)
%
xx             = (0.5:n_1-0.5)' * delta(1);
yy             = (0:n_2-1)' * delta(2);
zz             = (0:n_3-1)' * delta(3);
   
InOut          = locate_cyld(n_1,n_2,n_3,xx,yy,zz,cubic_length,rd_sphere,rd_cylinder);

idx_in         = find(InOut == 1);
diag_B(idx_in) = varepsilon_in * ones(length(idx_in),1);

%
% (II)
%
xx               = (0:n_1-1)' * delta(1);
yy               = (0.5:n_2-0.5)' * delta(2);
zz               = (0:n_3-1)' * delta(3);

InOut            = locate_cyld(n_1,n_2,n_3,xx,yy,zz,cubic_length,rd_sphere,rd_cylinder);

idx_in           = find(InOut == 1);
diag_B(n+idx_in) = varepsilon_in * ones(length(idx_in),1);

%
% (III)
%
xx                 = (0:n_1-1)' * delta(1);
yy                 = (0:n_2-1)' * delta(2);
zz                 = (0.5:n_3-0.5)' * delta(3);

InOut              = locate_cyld(n_1,n_2,n_3,xx,yy,zz,cubic_length,rd_sphere,rd_cylinder);

idx_in             = find(InOut == 1);
diag_B(2*n+idx_in) = varepsilon_in * ones(length(idx_in),1);

end

% =========================================================================
function [ InOut ] = locate_cyld(n_1,n_2,n_3,xx,yy,zz,cubic_length,rd_sphere,rd_cylinder)

n        = n_1 * n_2 * n_3;
xyz      = zeros(n,3);
xyz(:,1) = kron(ones(n_2*n_3,1),xx);

yy1      = kron(yy,ones(n_1,1));
xyz(:,2) = kron(ones(n_3,1),yy1);

xyz(:,3) = kron(zz,ones(n_1*n_2,1));

% idx      = find( xyz(:,1) > 0.5d0*cubic_length );
% if ( ~isempty(idx) )
%     xyz(idx,1) = xyz(idx,1) - cubic_length;
% end
% 
% idx      = find( xyz(:,2) > 0.5d0*cubic_length );
% if ( ~isempty(idx) )
%     xyz(idx,2) = xyz(idx,2) - cubic_length;
% end
% 
% idx      = find( xyz(:,3) > 0.5d0*cubic_length );
% if ( ~isempty(idx) )
%     xyz(idx,3) = xyz(idx,3) - cubic_length;
% end

xyz(:,1) = xyz(:,1) - 0.5d0*cubic_length;
xyz(:,2) = xyz(:,2) - 0.5d0*cubic_length;
xyz(:,3) = xyz(:,3) - 0.5d0*cubic_length;

InOut = zeros(n,1);

tmp1       = xyz(:,1).^2;
tmp2       = xyz(:,2).^2;
tmp3       = xyz(:,3).^2;

tmp        = tmp1 + tmp2;
tmp        = tmp.^(0.5);
idx        = find( tmp <= rd_cylinder );
InOut(idx) = ones(length(idx),1);

tmp        = tmp2 + tmp3;
tmp        = tmp.^(0.5);
idx        = find( tmp <= rd_cylinder );
InOut(idx) = ones(length(idx),1);

tmp        = tmp3 + tmp1;
tmp        = tmp.^(0.5);
idx        = find( tmp <= rd_cylinder );
InOut(idx) = ones(length(idx),1);

tmp        = tmp1 + tmp2 + tmp3;
tmp        = tmp.^(0.5);
idx        = find( tmp <= rd_sphere );
InOut(idx) = ones(length(idx),1);
end