function y = FFT_based_precond(rhs, Lambda, tau, EigDecompDoubCurl_cell, fun_mtx_TH_prod_vec, fun_mtx_T_prod_vec)
    % Precondition Linear System: Mx=b (M=A-sigma*epsilon*I) output:y=inv(M)*b
    
    n_123    = length(Lambda);

    sol  = zeros(3*n_123,1);
    for ii = 1:3
        sol((ii-1)*n_123+1:ii*n_123,1) = fun_mtx_TH_prod_vec(rhs((ii-1)*n_123+1:ii*n_123,1));
    end
    rhs  = sol;
    tmp  = conj(EigDecompDoubCurl_cell.Lambda_x).*sol(1:n_123,1) + ...
        conj(EigDecompDoubCurl_cell.Lambda_y).*sol(n_123+1:2*n_123,1) + ...
        conj(EigDecompDoubCurl_cell.Lambda_z).*sol(2*n_123+1:3*n_123,1);
    sol  = rhs-([ EigDecompDoubCurl_cell.Lambda_x.*tmp; EigDecompDoubCurl_cell.Lambda_y.*tmp; ...
        EigDecompDoubCurl_cell.Lambda_z.*tmp])/tau;
    
%    tmp  = Lambda - tau * ones(n_123,1);
    sol  = [ sol(1:n_123,1)./Lambda; sol(n_123+1:2*n_123)./Lambda; sol(2*n_123+1:3*n_123)./Lambda ];
    
    y = zeros(3*n_123,1);
    for ii = 1:3
        y((ii-1)*n_123+1:ii*n_123,1) = fun_mtx_T_prod_vec(sol((ii-1)*n_123+1:ii*n_123,1));
    end
    
% % 


