function [K,E,M1,F1,G1,Mn,Fn,Gn] = GetQEPMat(T,V,NX)

if isscalar(NX)
    if isreal(NX) && (NX > 0)
        ntype = 'constant';
    else
        error('n(x) must be a positive scalar.\n');
    end
elseif (~any(size(NX) ~= [3 3]) && (min(NX(NX~=0)) > 0)) % && (issymmetric(NX))
    ntype = 'symm_mat_3x3';
else
    error('n(x) must be a 3x3 symmetric matrix with positive entries.\n')
end

[EI,EB,ET,DPhi,VOL] = EdgeElement(T,V);

[K,E] = GetStifMat(EI,EB,ET,DPhi,VOL);
if strcmp(ntype,'constant')
    [M1,F1,G1] = GetMassMat(EI,EB,ET,DPhi,VOL);
else
    [M1,F1,G1,Mn,Fn,Gn] = GetMassMat(EI,EB,ET,DPhi,VOL,NX);
end

end
