function [K,E,SS] = GetStifMat(EI,EB,ET,DPhi,VOL)
% gradPhi : TNO x 3 x 4
% curlW   : TNO x 3 x 6

ENO   = max(max(ET));
TNO   = size(VOL,1);
curlW = zeros(TNO,3,6);
ei    = [1 1 1 2 2 3];
ej    = [2 3 4 3 4 4];
for k = 1:6
    curlW(:,:,k) = 2*cross(DPhi(:,:,ei(k)),DPhi(:,:,ej(k)));
end
% Construct the stiffness matrix (the curl-curl operator)
Aij = zeros(TNO,15);
k   = 1;
for i = 1:5
    for j = (i+1):6
        Aij(:,k) = dot(curlW(:,:,i),curlW(:,:,j),2).*VOL;   k = k + 1;
    end
end
ei = [1 1 1 1 1 2 2 2 2 3 3 3 4 4 5];
ej = [2 3 4 5 6 3 4 5 6 4 5 6 5 6 6];
SS  = sparse(ET(:,ei),ET(:,ej),Aij,ENO,ENO);

Aij = reshape(sum(curlW.*curlW,2),TNO,6,1);
for k = 1:6
    Aij(:,k) = Aij(:,k).*VOL;
end
SS  = SS + SS' + sparse(ET(:,1:6),ET(:,1:6),Aij,ENO,ENO);

K = SS(EI,EI);
E = SS(EI,EB);
%
end